/*
	Example file for communicating with the NFRC522. The program prints the card data.
	Created by Eelco Rouw - Originally adapted by Grant Gibson. 

2412 
SDA - P22
SCK - P15
MOSI - P16 (LED2 off)
MISO - P17
IRQ - NC
GND - GND
RST - P13
3.3V - VCC
jumper (TXD)|||||(vcc)
*/

#include <Mfrc522.h>

// the sensor communicates using SPI, so include the library:
#include <SPI.h>

int chipSelectPin = 10;
int NRSTDP = 5;
Mfrc522 Mfrc522(chipSelectPin,NRSTDP);
unsigned char serNum[5];


const int REL =  P2_3;
const int LED =  P2_4;
const int BUZ =  P2_5;

void setup() 
{                
	Serial.begin(9600);                       // RFID reader SOUT pin connected to Serial RX pin at 2400bps 
	// Start the SPI library:
	SPI.begin();
	// Initialize the Card Reader
	digitalWrite(chipSelectPin, LOW);
	pinMode(LED, OUTPUT);
	pinMode(BUZ, OUTPUT);
	pinMode(REL, OUTPUT);

	Mfrc522.Init();  
        Serial.println("RC522 test");
                digitalWrite(BUZ, HIGH);
 	        digitalWrite(LED, HIGH);
                delay(100);
                digitalWrite(LED, LOW);
                delay(100);
 	        digitalWrite(LED, HIGH);
                delay(100);
      	        digitalWrite(LED, LOW);
 	        digitalWrite(BUZ, LOW);
        
}

void loop()
{
	unsigned char i,tmp;
	unsigned char status;
	unsigned char str[MAX_LEN];
	unsigned char RC_size;
	unsigned char blockAddr;
	String mynum = "";
  	
	status = Mfrc522.Request(PICC_REQIDL, str);	
	if (status == MI_OK)
	{
		Serial.println("Card detected");
		Serial.print(str[0],BIN);
		Serial.print(" , ");
		Serial.print(str[1],BIN);
		Serial.println(" ");
   	        digitalWrite(LED, HIGH);
   	        digitalWrite(BUZ, HIGH);
                delay(200);
                digitalWrite(LED, LOW);
                digitalWrite(BUZ, LOW);
	}

	status = Mfrc522.Anticoll(str);
	memcpy(serNum, str, 5);
	if (status == MI_OK)
	{
		Serial.println("The card's number is  : ");
		Serial.print(serNum[0]);
		Serial.print(" , ");
		Serial.print(serNum[1],BIN);
		Serial.print(" , ");
		Serial.print(serNum[2],BIN);
		Serial.print(" , ");
		Serial.print(serNum[3],BIN);
		Serial.print(" , ");
		Serial.print(serNum[4],BIN);
		Serial.println(" ");
  	        digitalWrite(LED, HIGH);
                digitalWrite(BUZ, HIGH);
                delay(200);
                digitalWrite(LED, LOW);
                delay(200);
  	        digitalWrite(LED, HIGH);
                delay(200);
                digitalWrite(BUZ, LOW);
  	        digitalWrite(LED, LOW);

		// Should really check all pairs, but for now we'll just use the first

		if(serNum[0] == 141) 
		{
			Serial.println("Hello traxman");
			digitalWrite(LED, HIGH);
 	                digitalWrite(BUZ, HIGH);
  	                digitalWrite(REL, HIGH);
			delay(1000);
			digitalWrite(LED, LOW);
 	                digitalWrite(BUZ, LOW);
  	                digitalWrite(REL, LOW);
		}     
		delay(1000);	
	}
	//Serial.println(" ");
	Mfrc522.Halt();	                        
}
